osg::ValueMap Class Reference

`#include <ValueMap>`

Inheritance diagram for osg::ValueMap:

## Public Types

typedef std::map< osg::ref_ptr< const osg::Referenced >, osg::ref_ptr< osg::Object > > | KeyValueMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ValueMap ()
| ValueMap (const ValueMap &vm, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, ValueMap)
void | setKeyValueMap (KeyValueMap &properties)
KeyValueMap & | getKeyValueMap ()
const KeyValueMap & | getKeyValueMap () const
osg::Object * | setValue (const osg::Referenced *key, osg::Object *object)
template<typename T>
osg::Object * | setValue (const osg::Referenced *key, const T &value)
osg::Object * | getValue (const osg::Referenced *key)
const osg::Object * | getValue (const osg::Referenced *key) const
template<typename T>
T * | getValueOfType (const osg::Referenced *key)
template<typename T>
const T * | getValueOfType (const osg::Referenced *key) const
template<typename T>
bool | getValue (const osg::Referenced *key, T &value)
template<typename T>
bool | getValue (const osg::Referenced *key, T &value) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ValueMap ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

KeyValueMap | _keyValueMap
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## KeyValueMap

typedef std::map< osg::ref_ptr<const osg::Referenced>, osg::ref_ptr<osg::Object> > osg::ValueMap::KeyValueMap

## Constructor & Destructor Documentation

## ValueMap() [1/2]

osg::ValueMap::ValueMap | ( |  | ) |

Referenced by META_Object(), and ValueMap().

## ValueMap() [2/2]

osg::ValueMap::ValueMap | ( | const ValueMap & | vm,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References osg::CopyOp::SHALLOW_COPY, and ValueMap().

## ~ValueMap()

virtual osg::ValueMap::~ValueMap | ( |  | ) |

protected virtual

## Member Function Documentation

## getKeyValueMap() [1/2]

KeyValueMap & osg::ValueMap::getKeyValueMap | ( |  | ) |

inline

References _keyValueMap.

Referenced by osg::ValueStack::pop(), and osg::ValueStack::push().

## getKeyValueMap() [2/2]

const KeyValueMap & osg::ValueMap::getKeyValueMap | ( |  | ) | const

inline

References _keyValueMap.

## getValue() [1/4]

osg::Object * osg::ValueMap::getValue | ( | const osg::Referenced * | key | ) |

inline

References _keyValueMap.

Referenced by getValueOfType(), and getValueOfType().

## getValue() [2/4]

const osg::Object * osg::ValueMap::getValue | ( | const osg::Referenced * | key | ) | const

inline

References _keyValueMap.

## getValue() [3/4]

template<typename T>

bool osg::ValueMap::getValue | ( | const osg::Referenced * | key,
|  | T & | value )

inline

References getValueOfType().

## getValue() [4/4]

template<typename T>

bool osg::ValueMap::getValue | ( | const osg::Referenced * | key,
|  | T & | value ) const

inline

References getValueOfType().

## getValueOfType() [1/2]

template<typename T>

T * osg::ValueMap::getValueOfType | ( | const osg::Referenced * | key | ) |

inline

References getValue(), and osg::Object::Object().

Referenced by getValue(), and getValue().

## getValueOfType() [2/2]

template<typename T>

const T * osg::ValueMap::getValueOfType | ( | const osg::Referenced * | key | ) | const

inline

References getValue(), and osg::Object::Object().

## META_Object()

osg::ValueMap::META_Object | ( | osg | ,
|  | ValueMap | )

References ValueMap().

## setKeyValueMap()

void osg::ValueMap::setKeyValueMap | ( | KeyValueMap & | properties | ) |

inline

References _keyValueMap.

## setValue() [1/2]

template<typename T>

osg::Object * osg::ValueMap::setValue | ( | const osg::Referenced * | key,
|  | const T & | value )

inline

References _keyValueMap.

## setValue() [2/2]

osg::Object * osg::ValueMap::setValue | ( | const osg::Referenced * | key,
|  | osg::Object * | object )

inline

References _keyValueMap.

## Member Data Documentation

## _keyValueMap

KeyValueMap osg::ValueMap::_keyValueMap

protected

Referenced by getKeyValueMap(), getKeyValueMap(), getValue(), getValue(), setKeyValueMap(), setValue(), and setValue().

The documentation for this class was generated from the following file:

- ValueMap